<?php
/*********************************************************************************************
+ No Links Allowed v0.5 : A Plugin for MyBB 1.4 and 1.6
+ Free to Use
+ Free to Edit
+ But Not Allowed to distribute
**********************************************************************************************
ChangeLog:
v0.5: Updated to be use for MyBB 1.6.5
v0.4: Added Users post count and minimum posts required.
v0.3: Fixed the bug of "Wrong Data-type".
v0.2: Added an extra option (within the same settings) where you can now allowed to add "0" (without quotes) to have it enabled in all forums at once. This is useful if you've large forum with dozens of forums / subforums.
v0.1: Initial release of this plugin.
=======================================
*/
if(!defined("IN_MYBB")){
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}
function no_links_info(){
	return array(
		"name"			=> "No Links Allowed",		"description"	=> "This plugin used to deny posting links before reaching min. amount of posts.",		"website"		=> "http://yaldaram.com",		"author"		=> "Yaldaram",		"authorsite"	=> "http://yaldaram.com",		"version"		=> "0.5",		"compatibility" => "14*,16*"
	);
}
function no_links_activate(){
	global $db, $mybb;
	$no_links_group = array(
		"gid"			=> "NULL",		"name"			=> "no_links",		"title" 		=> "No Links Allowed",		"description"	=> "Settings for the plugin.",		"disporder"		=> "1",		"isdefault"		=> "no",
	);
	$db->insert_query("settinggroups", $no_links_group);
	$gid = $db->insert_id();
	$no_links_setting_1 = array(
		"sid"			=> "NULL",		"name"			=> "no_links_power",		"title"			=> "Power",		"description"	=> "Select Yes if you really wants this plugin to run.",		"optionscode"	=> "yesno",		"value"			=> "no",		"disporder"		=> "1",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $no_links_setting_1);
	$no_links_setting_2 = array(
		"sid"			=> "NULL",		"name"			=> "no_links_groups",		"title"			=> "Restricted_Groups",		"description"	=> "Specify who is not allowed to post link. Separate each with ,",		"optionscode"	=> "text",		"value"			=> "1,2,5",		"disporder"		=> "2",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $no_links_setting_2);
	$no_links_setting_3 = array(
		"sid"			=> "NULL",		"name"			=> "no_links_forums",		"title"			=> "Restricted_Forums",		"description"	=> "Specify where this plugin is functional. Separate each with ,<br />(OR add 0 to enable it to all forums)",		"optionscode"	=> "text",		"value"			=> "2,3",		"disporder"		=> "3",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $no_links_setting_3);
	$no_links_setting_4 = array(
		"sid"			=> "NULL",		"name"			=> "no_links_posts",		"title"			=> "Minimum_Posts",		"description"	=> "Specify minimum amount of posts.",		"optionscode"	=> "text",		"value"			=> "25",		"disporder"		=> "4",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $no_links_setting_4);
    rebuild_settings();
}
function no_links_deactivate(){
	global $db, $mybb;
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='no_links'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='no_links_power'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='no_links_groups'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='no_links_forums'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='no_links_posts'");
    rebuild_settings();
}
$plugins->add_hook("datahandler_post_validate_thread", "no_links_do");
$plugins->add_hook("datahandler_post_validate_post", "no_links_do");
function no_links_do(&$post){
	global $mybb, $fid;
	$power = $mybb->settings['no_links_power'];
	$group = $mybb->user['usergroup'];
	$groups = explode(",",$mybb->settings['no_links_groups']);
	$postcount = $mybb->user['postnum'];
	$posts = $mybb->settings['no_links_posts'];
	if ($power != "0"){
		if ($mybb->settings['no_links_forums'] != ""){
			$forums = explode(",",$mybb->settings['no_links_forums']);
		}
			if (in_array($fid,$forums) && in_array($group,$groups) && $posts > $postcount){
				if (preg_match('@((http|https|ftp|irc|http://www|www)://([-\w\.]+)+(:\d+)?(/([\w/_\.]*(\?\S+)?)?)?)@', $post->data['message'])){
					$post->is_validated = false;
					$post->set_error(sprintf("You cannot post clickable links to this forum threads and posts. Minimum post count is ".$posts." posts. But your post count is just ".$postcount." posts.", "No Links Allowed"));
					return $post;
				}
			}
		elseif ($mybb->settings['no_links_forums'] == 0){
			if (in_array($group,$groups) && $posts > $postcount){
				if (preg_match('@((http|https|ftp|irc|http://www|www)://([-\w\.]+)+(:\d+)?(/([\w/_\.]*(\?\S+)?)?)?)@', $post->data['message'])){
					$post->is_validated = false;
					$post->set_error(sprintf("You cannot post clickable links to this forum threads and posts. Minimum post count is ".$posts." posts. But your post count is just ".$postcount." posts.", "No Links Allowed"));
					return $post;
				}
			}
		}
	}
}
?>